"""add_expiration_date

Revision ID: 5ae9f7f5316a
Revises: 8b3d48c66e40
Create Date: 2021-04-06 15:30:51.589428

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '5ae9f7f5316a'
down_revision = '8b3d48c66e40'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column('indexes', sa.Column('expiration_date', sa.DateTime(timezone=True), nullable=True))
    op.create_index('indexes_expiration_date_idx', 'indexes', ['expiration_date'], unique=False, postgresql_where=sa.text('expiration_date IS NOT NULL AND date_removed IS NULL'))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('indexes_expiration_date_idx', table_name='indexes')
    op.drop_column('indexes', 'expiration_date')
    # ### end Alembic commands ###
