"""modify indexes

Revision ID: 8b3d48c66e40
Revises: e8d0d9f4962e
Create Date: 2021-01-15 17:38:07.290401

"""
from alembic import op

# revision identifiers, used by Alembic.
revision = '8b3d48c66e40'
down_revision = 'e8d0d9f4962e'
branch_labels = None
depends_on = None


def upgrade():
    op.drop_index('indexes_prefix_idx', table_name='indexes')
    op.create_index('indexes_date_removed_idx', 'indexes', ['date_removed'], unique=False)
    op.create_index('searchers_index_path_idx', 'searchers', ['index_path'], unique=False)

    conn = op.get_bind()

    conn.execute("ALTER TABLE indexes SET (fillfactor = 75)")
    conn.execute("CLUSTER indexes USING indexes_pkey")

    conn.execute("ALTER TABLE searchers SET (fillfactor = 75)")
    conn.execute("CLUSTER searchers USING searchers_pkey")


def downgrade():
    op.drop_index('indexes_date_removed_idx', table_name='indexes')
    op.drop_index('searchers_index_path_idx', table_name='searchers')
    op.create_index('indexes_prefix_idx', 'indexes', ['prefix'], unique=False)

    conn = op.get_bind()

    conn.execute("ALTER TABLE indexes SET (fillfactor = 100)")
    conn.execute("CLUSTER indexes USING indexes_pkey")

    conn.execute("ALTER TABLE searchers SET (fillfactor = 100)")
    conn.execute("CLUSTER searchers USING searchers_pkey")

