# We should move or remove this later, but just putting it here now for convience.


from leases_db_interface import DbManager
from multiprocessing import Pool, Process
from concurrent.futures import ThreadPoolExecutor


import uuid
import time


class Searcher:
    def __init__(self, dbmanager, container_id):
        self.id = container_id
        self.db_manager = dbmanager
        # self.merging_leases = []
        # self.optimized_leases = []
        self.count_merging = 5
        self.count_optimized = 10

    def get_leases(self):
        merging = self.db_manager.get_new_lease(self.id, True, 100)
        optimized = self.db_manager.get_new_lease(self.id, False, 1000)

        #print(f"Received Merging: {len(merging)} Optimized {len(optimized)}")
        # self.merging_leases += merging
        # self.optimized_leases += optimized

    def extend_leases(self):
        merging, optimized = self.db_manager.extend_leases(self.id)
        #print(f"Extended Merging: {len(merging)} Optimized {len(optimized)}")



user = "corey"
password = "testing"
#host = "127.0.0.1:27017"
host = "cluster1-rs0:27017"
db_name = "test"
uri = f"mongodb://{user}:{password}@{host}/{db_name}?serverSelectionTimeoutMS=2000"
#uri = f"mongodb://{user}:{password}@{host}/{db_name}?directConnection=true&serverSelectionTimeoutMS=2000"

def split_list(lst, chunk_size):
    chunks = [[] for _ in range((len(lst) + chunk_size - 1) // chunk_size)]
    for i, item in enumerate(lst):
        chunks[i // chunk_size].append(item)
    return chunks
def get_searcher_classes(searcher_uuids):
    searcher_classes = []
    db_manager = DbManager(uri)
    for searcher_uuid in searcher_uuids:
        searcher = Searcher(db_manager, searcher_uuid)
        searcher_classes.append(searcher)
    return searcher_classes

def get_leases(searcher_uuids, threads):
    def get_leases_thread(uuids):
        searcher_classes = get_searcher_classes(uuids)
        while True:
            start = time.time()
            for searcher in searcher_classes:
                #print(f"Getting leases for {searcher.id}")
                searcher.get_leases()
            end = time.time()
            #print(f"Got leases for all searchers in {end-start} seconds")
    searcher_uuid_chunks = split_list(searcher_uuids, threads)
    with ThreadPoolExecutor(max_workers=threads) as executor:
        executor.map(get_leases_thread, searcher_uuid_chunks)




def extend_leases(searcher_uuids, threads):
    def extend_leases_thread(uuids):
        searcher_classes = get_searcher_classes(searcher_uuids)
        while True:
            start = time.time()
            for searcher in searcher_classes:
                #print(f"Extending leases for {searcher.id}")
                searcher.extend_leases()
            end = time.time()
            print(f"Extended leases for all searchers in {end-start} seconds")
    searcher_uuid_chunks = split_list(searcher_uuids, threads)
    with ThreadPoolExecutor(max_workers=threads) as executor:
        executor.map(extend_leases_thread, searcher_uuid_chunks)


if __name__ == '__main__':
    searchers = []
    searchers_count = 2000
    for x in range(searchers_count):
        searchers.append(str(uuid.uuid4()))
    p_leasing = Process(target=get_leases, args=(searchers, 10))
    p_extending = Process(target=extend_leases, args=(searchers, 1))
    p_leasing.start()
    p_extending.start()
    #extend_leases(searchers)

